Doomsday Engine - Bug #1634

[Hexen] Hypostyle: Death Wyvern gets stuck
2013-10-22 16:03 - skyjake

Status: Closed Start date: 2013-10-22
Priority: High % Done: 100%
Assignee: skyjake

Category: Regression

Target version: 1.15

Description

While playing through Hypostyle's boss battle (flying dragon thing in big lava room), it got stuck in the base of the room's center pillar
and was easily killable.

Not sure if it was a one-off issue or a reproduceable bug. Should be retested.

See: description of the map

Associated revisions

Revision Ocefba7b - 2015-05-21 09:59 - skyjake

Fixed|Hexen: Death Wyvern gets stuck

The main trigger for the Wyvern getting stuck was that it chased the
dead Ettin that sometimes falls on the lava. If the Ettin is too

close to the central pillar, the Wyvern's requirement to get close
enough to the target was impossible.

Now the Wyvern just forgets about the Ettin after it has died.

Fixed the incorrect use of FIX2FLT (we're using coord_t),
addressed compiler warnings about calling abs() on an unsigned int,
and cleaned up the code a little.

IssuelD #1634

Revision d7048727 - 2015-05-21 11:24 - skyjake

Fixed|Hexen: Death Wyvern gets stuck

The main trigger for the Wyvern getting stuck was that it chased the
dead Ettin that sometimes falls on the lava. If the Ettin is too

close to the central pillar, the Wyvern's requirement to get close
enough to the target was impossible.

Now the Wyvern just forgets about the Ettin after it has died.

Fixed the incorrect use of FIX2FLT (we're using coord_t),
addressed compiler warnings about calling abs() on an unsigned int,

and cleaned up the code a little.

IssuelD #1634

History

#1 - 2013-10-22 23:40 - danij

I've seen this happen a few times, though | can't be certain whether its not also present in vanilla (needs testing).

#2 - 2013-10-22 23:45 - vermil

I believe the Death Wyvern's flight Al does have a flaw that can cause it to fly into the middle pillar under some circumstances. However, while it can
get stuck on it for a short while, | can't recall it ever flying down to the floor and getting stuck permanently.

#3 - 2013-10-22 23:59 - danij

| suspect that specific behavior (flying down to the floor) is a actually a symptom of a more general broken flier behavior (we already know DOOM and
Heretic suffer from this).
http://doomwiki.org/wiki/Hub_2:_Hypostyle

#4 - 2013-10-22 23:59 - vermil
I've just tested the Wyvern battle and after killing the Ettin in the middle it dropped down to the floor and stayed there.

| wonder if it's related to a bug I've raised with Danid before; that flying bad guys currently instantly drop to the floor upon killing something...

...0One notes that the Wyvern's height seemed determined by the Ettin's corpse; if/when the Ettin's corpse goes over the edge of the pillar and into the
lava, the Wyvern goes down with it. Though unlike fliers in Doom and Heretic, the move isn't instant and it also seems unable to raise back up.

#5 - 2013-10-23 00:15 - vermil
Also, bad Skyjake: Wrong wiki :p

http://www.doomworld.com/vb/doom-general/52973-doom-wiki/
http://www.doomworld.com/vb/doom-general/57079-doomwiki-org-is-now-open/

The Doom community forked the wiki from Wika a couple of years ago after disagreeing with Wika's then new, advert dominated layout.

The Doom wiki, as used by the Doom community (and hence where the most up-to-date technical details on Doom) is now here:
http://doomwiki.org/wiki/Entryway.

#6 - 2013-10-23 08:05 - skyjake
- Description updated

- Priority changed from Lowest to High
I've raised the priority as this sounds reproducible.
(Also updated wiki link.)

#7 - 2014-05-18 01:57 - JGondek

| can confirm this bug. A temporary workaround is to shoot the Ettin on the pillar along with the Wyvern so that its corpse won't get pushed down to
the lava (might need a few retries). Then, the dragon flies as it should.

#8 - 2015-05-20 21:40 - skyjake
- Assignee set to skyjake

- Target version set to 1.15

| started looking into this bug during my 1.15 RC playthrough. | feel like I'm close to a solution. The key is that the Wyvern should forget about the
Ettin if it falls down (i.e., is already dead) and just continue pursuing the invisible flight targets.

#9 - 2015-05-20 22:03 - vermil
The Wyvern does actually still follow it's invisible flight target's,but at the wrong height, which causes it to ultimately crash into the pillar.

Could it be related to the issue | mentioned in the comments of this tracker item; that flyers instantly jump to the height of their target when they kill
them?

http://tracker.skyjake.fi/issues/1129

| didn't mention bad guy infighting in said comment, but since then I've witnessed flyers instantly jumping when they kill another bad guy they are
targeting, as well as the player.

EDIT: Whoops, I've realized | basically wrote the above 4 comments up; though | didn't link to the report back then. My apologies.
#10 - 2015-05-20 22:10 - skyjake

- Status changed from New to Resolved

- % Done changed from 0 to 100

#11 - 2015-05-20 22:14 - skyjake
vermil wrote:
Could it be related to the issue | mentioned in the comments of this tracker item; that flyers instantly jump to the height of their target when they

kill them?

| don't think it's related, not at least very directly. What you're talking about probably has more to do with mobj Z collision checking when flying. The
Wyvern has its own very specific flight logic that was going wrong here.
#12 - 2015-05-21 11:25 - skyjake

- Status changed from Resolved to Closed
